library hex;

import 'dart:typed_data';

const int _radix = 16;

///base16
String base16encode(final Uint8List bytes) => (StringBuffer()..writeAll(
    [ for(final int byte in bytes) byte.toRadixString(_radix).padLeft(2, "0")]
)).toString();

///We assume [hex.length] % 2 == 0
///doesn't run checks
Uint8List base16decode(final String hex)=> Uint8List.fromList([for(int i=0; i<hex.length ; i+=2) int.parse(hex.substring(i, i+2), radix: _radix)]);
